SystemOrganization addCategory: #ClassFilter!

Object subclass: #ClassFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassFilter'!

!ClassFilter class methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 23:31'!
with: anObject

	"create an instance"
	^self subclassResponsibility! !

!ClassFilter methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 23:30'!
value: aClass

	"return a boolean"
	^self subclassResponsibility.! !

ClassFilter subclass: #ClassFilterWithClass
	instanceVariableNames: 'referenceClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassFilter'!

ClassFilterWithClass subclass: #ClassFilterClassIs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassFilter'!

!ClassFilterClassIs methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 23:35'!
value: aClass 

	^aClass == referenceClass! !

ClassFilterWithClass subclass: #ClassFilterInheritsFrom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassFilter'!

!ClassFilterInheritsFrom methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 23:55'!
value: aClass

	^aClass includesBehavior: referenceClass! !

!ClassFilterWithClass class methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 23:29'!
with: aClass

	^self new referenceClass: aClass! !

!ClassFilterWithClass methodsFor: 'accessing' stamp: 'hjo 8/8/2012 23:28'!
referenceClass
	^ referenceClass! !

!ClassFilterWithClass methodsFor: 'accessing' stamp: 'hjo 8/8/2012 23:28'!
referenceClass: aClass
	referenceClass := aClass
! !

ClassFilter subclass: #ClassFilterWithClasses
	instanceVariableNames: 'positiveClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassFilter'!

ClassFilterWithClasses subclass: #ClassFilterSuperclassOrClassIs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassFilter'!

!ClassFilterSuperclassOrClassIs class methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 23:39'!
with: aClass

	^self new positiveClasses: {aClass}, aClass allSuperclasses.! !

!ClassFilterSuperclassOrClassIs methodsFor: 'as yet unclassified' stamp: 'hjo 8/30/2012 10:03'!
positiveClasses
	^positiveClasses! !

!ClassFilterSuperclassOrClassIs methodsFor: 'accessing' stamp: 'hjo 8/8/2012 23:53'!
positiveClasses: anArray 

	positiveClasses := anArray! !

!ClassFilterSuperclassOrClassIs methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/1/2012 19:24'!
representingClass
	^positiveClasses first ! !

!ClassFilterSuperclassOrClassIs methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 23:38'!
value: aClass

	^positiveClasses includes: aClass! !

ClassFilter subclass: #ClassFilterWithStringOrSymbol
	instanceVariableNames: 'stringOrSymbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassFilter'!

ClassFilterWithStringOrSymbol subclass: #ClassFilterByName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassFilter'!

!ClassFilterByName methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 23:33'!
value: aClass

	^ (aClass name findString: stringOrSymbol startingAt: 1 caseSensitive: false) > 0
! !

ClassFilterWithStringOrSymbol subclass: #ClassFilterCanUnderstand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassFilter'!

!ClassFilterCanUnderstand methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 23:33'!
value: aClass 

	^aClass canUnderstand: stringOrSymbol.! !

ClassFilterWithStringOrSymbol subclass: #ClassFilterCategoryIs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassFilter'!

!ClassFilterCategoryIs methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 23:47'!
value: aClass

	^aClass category = stringOrSymbol! !

ClassFilterWithStringOrSymbol subclass: #ClassFilterNameBeginsWith
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassFilter'!

!ClassFilterNameBeginsWith methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 23:40'!
value: aClass

	^aClass name beginsWith: stringOrSymbol! !

!ClassFilterWithStringOrSymbol class methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 23:29'!
with: anObject

	^self new stringOrSymbol: anObject! !

!ClassFilterWithStringOrSymbol methodsFor: 'accessing' stamp: 'hjo 8/8/2012 23:28'!
stringOrSymbol
	^ stringOrSymbol! !

!ClassFilterWithStringOrSymbol methodsFor: 'accessing' stamp: 'hjo 8/8/2012 23:28'!
stringOrSymbol: anObject
	stringOrSymbol := anObject! !
